//--------------------------------------------------------------------
//                                                                    
//  Module:       SalesMasterDetail                                       
//  Description:  SalesMasterDetail
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class SalesMasterDetail extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPChiselFramePanel ChiselPanel1;
	Panel MasterDetail1;
	Panel Panel1;
	Panel Panel2;
	JDPScrollPanel ScrollPanel1;
	Label stor_idLabel1;
	TextField b_stor_id1;
	Label stor_nameLabel1;
	TextField b_stor_name1;
	Label stor_addressLabel1;
	TextField b_stor_address1;
	Label cityLabel1;
	Panel cityLine1;
	TextField b_city1;
	TextField b_state1;
	TextField b_zip1;
	Label ord_numLabel1;
	TextField a_ord_num1;
	Label ord_dateLabel1;
	JDPDate a_ord_date1;
	JDPTextGrid MasterDetail1GL1;
	JDPButtons JDPButtons1;
	Panel Panel3;
	JDPWhereClause MasterDetail1SP1;
	JDPSearchResults MasterDetail1RL1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		ChiselPanel1 = new JDPChiselFramePanel(user, "Sales Detail Inquiry");
		MasterDetail1 = new Panel();
		Panel1 = new Panel();
		Panel2 = new Panel();
		ScrollPanel1 = new JDPScrollPanel();
		stor_idLabel1 = new Label("Store Id:", Label.LEFT);
		b_stor_id1 = new TextField("b.stor_id", 6);
		stor_nameLabel1 = new Label("Name:", Label.LEFT);
		b_stor_name1 = new TextField("b.stor_name", 42);
		stor_addressLabel1 = new Label("Address:", Label.LEFT);
		b_stor_address1 = new TextField("b.stor_address", 42);
		cityLabel1 = new Label("", Label.LEFT);
		cityLine1 = new Panel();
		b_city1 = new TextField("b.city", 22);
		b_state1 = new TextField("b.state", 4);
		b_zip1 = new TextField("b.zip", 7);
		ord_numLabel1 = new Label("Order Number:", Label.LEFT);
		a_ord_num1 = new TextField("a.ord_num", 20);
		ord_dateLabel1 = new Label("Order Date:", Label.LEFT);
		a_ord_date1 = new JDPDate(user,"", 19);
		MasterDetail1GL1 = new JDPTextGrid(user);
		String[] JDPButtons1btns = {"Apply","Refresh","Remove"};
		int[] JDPButtons1icns = {JDPButton.getIconValue("Save"),JDPButton.getIconValue("Undo"),JDPButton.getIconValue("Delete")};
		JDPButtons1 = new JDPButtons(user, JDPButtons1btns, JDPButtons1icns, JDPButtons.getAlignmentValue("Horizontal"));
		Panel3 = new Panel();
				
		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", ChiselPanel1);
		ChiselPanel1.add("Center", MasterDetail1);
		MasterDetail1.setLayout(new BorderLayout());
		MasterDetail1Main();
		MasterDetail1.add("Center", Panel1);
		Panel1.setLayout(new BorderLayout());
		Panel1.add("North", Panel2);
		Panel2.setLayout(new BorderLayout());
		Panel2.add("Center", ScrollPanel1);
		ScrollPanel1.add("Left", stor_idLabel1);
		ScrollPanel1.add("Right", b_stor_id1);
		ScrollPanel1.add("Left", stor_nameLabel1);
		ScrollPanel1.add("Right", b_stor_name1);
		ScrollPanel1.add("Left", stor_addressLabel1);
		ScrollPanel1.add("Right", b_stor_address1);
		ScrollPanel1.add("Left", cityLabel1);
		ScrollPanel1.add("Right", cityLine1);
		cityLine1.setLayout(new JDPLineLayout());
		cityLine1.add("Left", b_city1);
		cityLine1.add("Left", b_state1);
		cityLine1.add("Left", b_zip1);
		ScrollPanel1.add("Left", ord_numLabel1);
		ScrollPanel1.add("Right", a_ord_num1);
		ScrollPanel1.add("Left", ord_dateLabel1);
		ScrollPanel1.add("Right", a_ord_date1);
		Panel1.add("Center", MasterDetail1GL1);
		Panel1.add("South", JDPButtons1);
		MasterDetail1.add("West", Panel3);
		Panel3.setLayout(new BorderLayout());
		Panel3.add("North", MasterDetail1SP1);
		Panel3.add("Center", MasterDetail1RL1);

		stor_idLabel1.setFont(new Font("Helvetica", Font.BOLD, 11));
		b_stor_id1.setEditable(false);
		popuppanel.addComponent(b_stor_id1 ,"Stor Id" ,"");
		b_stor_id1.setEditable(false);
		stor_nameLabel1.setFont(new Font("Helvetica", Font.BOLD, 11));
		b_stor_name1.setEditable(false);
		popuppanel.addComponent(b_stor_name1 ,"Stor name" ,"");
		b_stor_name1.setEditable(false);
		stor_addressLabel1.setFont(new Font("Helvetica", Font.BOLD, 11));
		b_stor_address1.setEditable(false);
		popuppanel.addComponent(b_stor_address1 ,"Stor Address" ,"");
		b_stor_address1.setEditable(false);
		cityLabel1.setFont(new Font("Helvetica", Font.BOLD, 11));
		b_city1.setEditable(false);
		popuppanel.addComponent(b_city1 ,"City" ,"");
		b_city1.setEditable(false);
		b_state1.setEditable(false);
		popuppanel.addComponent(b_state1 ,"State" ,"");
		b_state1.setEditable(false);
		b_zip1.setEditable(false);
		popuppanel.addComponent(b_zip1 ,"Zip" ,"");
		b_zip1.setEditable(false);
		ord_numLabel1.setFont(new Font("Helvetica", Font.BOLD, 11));
		popuppanel.addComponent(a_ord_num1 ,"Ord Num" ,"");
		ord_dateLabel1.setFont(new Font("Helvetica", Font.BOLD, 11));
		popuppanel.addComponent(a_ord_date1 ,"Ord Date" ,"");


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.KEY_PRESS:
			if (e.key == '\t' && e.modifiers != Event.SHIFT_MASK) {
				if (e.target.equals(b_stor_id1)) { user.u.cursor(b_stor_name1); return true; }
				if (e.target.equals(b_stor_name1)) { user.u.cursor(b_stor_address1); return true; }
				if (e.target.equals(b_stor_address1)) { user.u.cursor(b_city1); return true; }
				if (e.target.equals(b_city1)) { user.u.cursor(b_state1); return true; }
				if (e.target.equals(b_state1)) { user.u.cursor(b_zip1); return true; }
				if (e.target.equals(b_zip1)) { user.u.cursor(a_ord_num1); return true; }
				if (e.target.equals(a_ord_num1)) { user.u.cursor(a_ord_date1); return true; }
				if (e.target.equals(a_ord_date1)) { user.u.cursor(b_stor_id1); return true; }
			}
			if (e.key == '\t' && e.modifiers == Event.SHIFT_MASK) {
				if (e.target.equals(b_stor_id1)) { user.u.cursor(a_ord_date1); return true; }
				if (e.target.equals(b_stor_name1)) { user.u.cursor(b_stor_id1); return true; }
				if (e.target.equals(b_stor_address1)) { user.u.cursor(b_stor_name1); return true; }
				if (e.target.equals(b_city1)) { user.u.cursor(b_stor_address1); return true; }
				if (e.target.equals(b_state1)) { user.u.cursor(b_city1); return true; }
				if (e.target.equals(b_zip1)) { user.u.cursor(b_state1); return true; }
				if (e.target.equals(a_ord_num1)) { user.u.cursor(b_zip1); return true; }
				if (e.target.equals(a_ord_date1)) { user.u.cursor(a_ord_num1); return true; }
			}
			return false;

		case Event.ACTION_EVENT:
			if (e.target.equals(JDPButtons1.button[0])) {
				MasterDetail1UpdateRows(MasterDetail1RL1.getSelectedKey());
				return true;
			}
			if (e.target.equals(JDPButtons1.button[1])) {
				MasterDetail1LoadGrid(MasterDetail1RL1.getSelectedKey());
				return true;
			}
			if (e.target.equals(JDPButtons1.button[2])) {
				MasterDetail1DeleteRows(MasterDetail1RL1.getSelectedKey());
				return true;
			}
			if (e.target.equals(MasterDetail1SP1)) {
				MasterDetail1RL1.clearList();
				MasterDetail1RL1.setFromWhereClause(MasterDetail1SP1.getFromWhereClause());
				MasterDetail1RL1.loadList();
				return true;
			}
			if (e.target.equals(MasterDetail1RL1)) {
				MasterDetail1Load(MasterDetail1RL1.getSelectedKey());
				MasterDetail1LoadGrid(MasterDetail1RL1.getSelectedKey());
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		jaggSQL.setKeepConnectionOpen(false);

	}

	//
	//  Main initialization method
	//
	public void MasterDetail1Main() {

		MasterDetail1ClearFields();
		MasterDetail1SetGridSettings();
		MasterDetail1LoadChoices();
		MasterDetail1WhereClauseMain();
		MasterDetail1SearchResultsMain();

	}


	//
	//  Load the selected item
	//
	public void MasterDetail1Load(String[] keys) {

		StringTokenizer stok;

		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		int actualRows = 0;
		String row;
		String tempText;

		if (keys == null || keys.length < 0) {
			MasterDetail1ClearFields();
			return;
		}

		String SQL = "SELECT a.ord_num," +
					"a.ord_date," +
					"b.stor_id," +
					"b.stor_name," +
					"b.stor_address," +
					"b.city," +
					"b.state," +
					"b.zip" +
					" FROM {oj dbo_sales a LEFT OUTER JOIN dbo_stores b ON a.stor_id = b.stor_id}" +
					" WHERE (1=1)";
		if (keys.length > 0 && keys[0] != null) SQL += " AND a.stor_id='" + keys[0]+ "'" ;
		if (keys.length > 1 && keys[1] != null) SQL += " AND a.ord_num='" + keys[1]+ "'" ;
		if (keys.length > 2 && keys[2] != null) SQL += " AND a.title_id='" + keys[2]+ "'" ;

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);
		recCount = jaggSQL.execSQL(SQL, results);

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return;
		}
		if(recCount >= 1) {
			row = (String)results.elementAt(0);
			if ((row != null) && (row.trim().compareTo("") != 0)) {
				stok = new StringTokenizer(row,sep);
				a_ord_num1.setText(stok.nextToken().trim());
				a_ord_date1.setText(JDPDate.format(Long.valueOf(stok.nextToken()).longValue()));
				b_stor_id1.setText(stok.nextToken().trim());
				b_stor_name1.setText(stok.nextToken().trim());
				b_stor_address1.setText(stok.nextToken().trim());
				b_city1.setText(stok.nextToken().trim());
				b_state1.setText(stok.nextToken().trim());
				b_zip1.setText(stok.nextToken().trim());
			}
			if(recCount > 1) {
				user.mainmsg.setStatusMsg(JDPLang.get("Message1"), 10);
			} else {
				user.mainmsg.clearStatusMsg();
			}
		} else {
			user.mainmsg.setStatusMsg(JDPLang.get("Message2"), 10);
			MasterDetail1ClearFields();
		}

	}


	//
	//  Clear the screen fields for a new option
	//
	public void MasterDetail1ClearFields() {

		a_ord_num1.setText("");
		a_ord_date1.setText("");
		b_stor_id1.setText("");
		b_stor_name1.setText("");
		b_stor_address1.setText("");
		b_city1.setText("");
		b_state1.setText("");
		b_zip1.setText("");

	}


	//
	//  Perform component validations
	//
	public boolean MasterDetail1CheckFields() {


		return true;

	}



	//
	//  Load the grid with the specified parameters and selected data
	//
	public void MasterDetail1LoadGridFromWhereClause(String whereClause) {

		int fPos = whereClause.indexOf("WHERE ");
		whereClause = " AND" + whereClause.substring(fPos+5);
		String[] keys = new String[0];

		MasterDetail1LoadGridMain(keys, whereClause);
	}


	//
	//  Load the grid with the specified parameters and selected data
	//
	public void MasterDetail1LoadGrid(String[] keys) {

		MasterDetail1LoadGridMain(keys, null);
	}


	//
	//  Load the grid with the specified parameters and selected data
	//
	void MasterDetail1LoadGridMain(String[] keys, String whereClause) {

		JDPTextGrid tableContents = MasterDetail1GL1;

		StringTokenizer stok;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		int actualRows = 0;
		String row;
		int columnCount = 3;

		Vector columns = new Vector();
		Vector indexes = new Vector();

		String SQL = "SELECT a.stor_id, " +
					"a.ord_num, " +
					"a.title_id, " +
					"a.title_id, " +
					"a.qty, " +
					"a.payterms FROM {oj dbo_sales a LEFT OUTER JOIN dbo_stores b ON a.stor_id = b.stor_id} WHERE (1=1)  ";
		if (keys.length > 0 && keys[0] != null) SQL += " AND a.stor_id='" + keys[0]+ "'" ;
		if (keys.length > 1 && keys[1] != null) SQL += " AND a.ord_num='" + keys[1]+ "'" ;
		if (keys.length > 2 && keys[2] != null) SQL += " AND a.title_id='" + keys[2]+ "'" ;
		if (whereClause != null) {
			SQL += whereClause;
		}

		user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		recCount = jaggSQL.execSQL(SQL, results);

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return;
		}

		//
		//  Initialise result arrays
		//
		tableContents.totalDataRows = jaggSQL.getRowCount();
		actualRows = jaggSQL.getRowCount()+20;
		tableContents.currentText = new String[columnCount][actualRows];

		tableContents.cellChanged = null;
		tableContents.rowChanged = null;
		tableContents.columnSelected = null;
		int keyCount = 3;
		tableContents.rowKey = new String[actualRows][keyCount];
		tableContents.recordLockValue = new String[actualRows];
		
		//
		//  Load key array and grid array
		//
		String tempText;
		for (int ix=0; ix<actualRows-20; ix++) {
			row = (String)results.elementAt(ix);
			if ((row != null) && (row.trim().compareTo("") != 0)) {
				stok = new StringTokenizer(row,sep);
				for (int iy=0; iy<keyCount; iy++) {
					tableContents.rowKey[ix][iy] = stok.nextToken().trim();
				}
				for (int iy=0; iy<columnCount; iy++) {
					tempText = stok.nextToken().trim();
					tableContents.currentText[iy][ix] = tempText;
					if ((iy == 0) && (tableContents.pullDownValue[0][0].indexOf(tempText) >= 0)) tableContents.currentText[iy][ix] = tableContents.pullDownList[0][0].getItem(tableContents.pullDownValue[0][0].indexOf(tempText));
					if ((iy == 2) && (tableContents.pullDownValue[2][0].indexOf(tempText) >= 0)) tableContents.currentText[iy][ix] = tableContents.pullDownList[2][0].getItem(tableContents.pullDownValue[2][0].indexOf(tempText));
				}
			}
		}
		for (int ix=actualRows-20; ix<actualRows; ix++) {
			for (int iy=0; iy<keys.length; iy++) {
				tableContents.rowKey[ix][iy] = keys[iy];
			}
		}

		tableContents.newTable();

		//
		//  Clear status message
		//
		user.mainmsg.clearStatusMsg();
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	public void MasterDetail1UpdateRowsFromWhereClause(String whereClause) {

		int fPos = whereClause.indexOf("WHERE ");
		whereClause = " AND" + whereClause.substring(fPos+5);
		String[] keys = new String[0];

		MasterDetail1UpdateRowsMain(keys, whereClause);
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	public void MasterDetail1UpdateRows(String[] keys) {

		MasterDetail1UpdateRowsMain(keys, null);
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	void MasterDetail1UpdateRowsMain(String[] keys, String whereClause) {

		JDPTextGrid tableContents = MasterDetail1GL1;

		int changedCount = 0;
		int insertedCount = 0;
		int cCount = 1;
		int iCount = 1;
		boolean reload = false;
		
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowChanged[ix]) {
				if (ix >= tableContents.totalDataRows) {
					insertedCount++;
				} else {
					changedCount++;
				}
			}
		}
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowChanged[ix]) {
				if (ix >= tableContents.totalDataRows) {
					user.mainmsg.setStatusMsg(JDPLang.get("Message7",iCount++,insertedCount), 0);
					MasterDetail1SaveData(ix,"I");
				} else {
					user.mainmsg.setStatusMsg(JDPLang.get("Message8",cCount++,changedCount), 0);
					if (MasterDetail1SaveData(ix,"U")) {
						reload = true;
					}
				}
				tableContents.rowChanged[ix] = false;
			}
		}
		if (insertedCount > 0 || reload) {
			MasterDetail1LoadGridMain(keys, whereClause);
		}
	}


	//
	//  Delete any of the selected rows
	//
	public void MasterDetail1DeleteRowsFromWhereClause(String whereClause) {

	int fPos = whereClause.indexOf("WHERE ");
		whereClause = " AND" + whereClause.substring(fPos+5);
		String[] keys = new String[0];

		MasterDetail1DeleteRowsMain(keys, whereClause);
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	public void MasterDetail1DeleteRows(String[] keys) {

		MasterDetail1DeleteRowsMain(keys, null);
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	void MasterDetail1DeleteRowsMain(String[] keys, String whereClause) {

		JDPTextGrid tableContents = MasterDetail1GL1;

		int deletedCount = 0;
		int cCount = 1;
		int iCount = 1;
		
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowSelected[ix]) {
				deletedCount++;
			} 
		}
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowSelected[ix]) {
				user.mainmsg.setStatusMsg(JDPLang.get("Message9",iCount++,deletedCount), 0);
				MasterDetail1SaveData(ix,"D");
			}
		}
		if (deletedCount > 0) {
			MasterDetail1LoadGridMain(keys, whereClause);
		}
	}


	//
	//  Save the selected item
	//
	boolean MasterDetail1SaveData(int tableRow, String action) {

		JDPTextGrid tableContents = MasterDetail1GL1;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		String SQL = "";
		String prevSQL = null;

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		if (action.equals("I")) {
			SQL = "INSERT INTO dbo_sales (stor_id, " +
					"ord_num, " +
					"title_id, " +
					"qty, " +
					"payterms, " +
					"ord_date) VALUES('" + tableContents.rowKey[tableRow][0] + "', " +
					"'" + tableContents.rowKey[tableRow][1] + "', " +
					"'" + (String)tableContents.pullDownValue[0][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[0][0],tableContents.currentText[0][tableRow])) + "', " +
					"" + JDPUtils.tonum(tableContents.currentText[1][tableRow]) + ", " +
					"'" + (String)tableContents.pullDownValue[2][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[2][0],tableContents.currentText[2][tableRow])) + "', " +
					"'" + JDPDate.format("") + "')";
		} else {
			if (action.equals("D")) {
				SQL = "DELETE FROM dbo_sales" +
					" WHERE stor_id='" + tableContents.rowKey[tableRow][0]+ "'"  +
					" AND ord_num='" + tableContents.rowKey[tableRow][1]+ "'"  +
					" AND title_id='" + tableContents.rowKey[tableRow][2]+ "'" ;
				if (tableContents.recordLockValue[tableRow] != null) {
					prevSQL = SQL;
				}
			} else {
				SQL = "UPDATE dbo_sales SET qty = " + JDPUtils.tonum(tableContents.currentText[1][tableRow]) + ", " +
					"payterms = '" + (String)tableContents.pullDownValue[2][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[2][0],tableContents.currentText[2][tableRow])) + "'" +
					" WHERE stor_id='" + tableContents.rowKey[tableRow][0]+ "'"  +
					" AND ord_num='" + tableContents.rowKey[tableRow][1]+ "'"  +
					" AND title_id='" + tableContents.rowKey[tableRow][2]+ "'" ;
				if (tableContents.recordLockValue[tableRow] != null) {
					prevSQL = SQL;
				}
			}
		}

		recCount = jaggSQL.execSQL(SQL, results);

		if (user.DEBUG) System.out.println("saveData CNT: "+Integer.toString(recCount));

		if (recCount == 0 && prevSQL != null) {
			String[] buttons = {"Reload","Update"};
			int[] icons = {JDPButton.UNDO,JDPButton.SAVE};
			JDPMessageDialog d = new JDPMessageDialog(user, user.jdpMainWindow, JDPLang.get("Dialog0"), JDPLang.get("Dialog1"), buttons, icons);
			d.display();
			if (d.getPressedButton() == 1) {
				results = new Vector();
				recCount = jaggSQL.execSQL(prevSQL, results);
			} else {
				return true;
			}
		}

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return false;
		}
		if(recCount == 1) {
			if (action.equals("I")) {
				user.mainmsg.setStatusMsg(JDPLang.get("Message4"),3);
			} else 
			if (action.equals("D")) {
				user.mainmsg.setStatusMsg(JDPLang.get("Message5"),3);
			} else {
				user.mainmsg.setStatusMsg(JDPLang.get("Message6"),3);
			}
		} else {
			user.u.setSqlMessage(jaggSQL,SQL);
		}
		if (prevSQL != null) {
			return true;
		}
		return false;

	}


	//
	//  Load the grid with the blank rows to allow data entry
	//
	public void MasterDetail1LoadEmptyGrid() {

		JDPTextGrid tableContents = MasterDetail1GL1;
		int columnCount = 3;

		tableContents.currentText = new String[columnCount][50];
		tableContents.cellChanged = null;
		tableContents.rowChanged = null;
		tableContents.columnSelected = null;
		tableContents.rowKey = new String[50][1];
		tableContents.newTable();
		tableContents.totalDataRows = 0;
	}


	//
	//  Set up the parameters for this grid
	//
	void MasterDetail1SetGridSettings() {

		if (MasterDetail1 == null) {
			MasterDetail1 = new JDPTextGrid(user);
		} 
		JDPTextGrid tableContents = MasterDetail1GL1;
		int columnCount = 3;

		tableContents.columnHeader = new String[columnCount];
		tableContents.columnHeaderStyle = new int[columnCount];
		tableContents.columnStyle = new int[columnCount];
		tableContents.columnHeaderColor = new Color[columnCount];
		tableContents.columnColor = new Color[columnCount];
		tableContents.columnBGColor = new Color[columnCount];
		tableContents.columnProtected = new boolean[columnCount];
		tableContents.columnWidth = new int[columnCount];
		tableContents.rightJustify = new boolean[columnCount];
		tableContents.rowHeader = null;
		tableContents.columnHeight = null;
		for (int ix=0; ix<columnCount; ix++) {
			tableContents.columnHeaderStyle[ix] = Font.BOLD;
			tableContents.columnStyle[ix] = Font.PLAIN;
			tableContents.columnHeaderColor[ix] = Color.black;
			tableContents.columnColor[ix] = Color.black;
			tableContents.columnBGColor[ix] = Color.white;
			tableContents.columnStyle[ix] = Font.PLAIN;
		}
		tableContents.columnProtected[0] = true;
		tableContents.columnProtected[2] = true;
		tableContents.columnWidth[0] = 307;
		tableContents.columnWidth[1] = 52;
		tableContents.columnWidth[2] = 100;
		tableContents.rightJustify[1] = true;
		tableContents.columnHeader[0] = "Title";
		tableContents.columnHeader[1] = "Quantity";
		tableContents.columnHeader[2] = "Terms";

		MasterDetail1LoadEmptyGrid();
	}


	//
	//  Load all of the Screen Choices
	//
	void MasterDetail1LoadChoices() {

		JDPTextGrid tableContents = MasterDetail1GL1;
		int columnCount = 3;

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		tableContents.isPullDownCol = new boolean[columnCount];
		tableContents.pullDownColType = new int[columnCount];
		tableContents.pullDownList = new List[columnCount][1];
		tableContents.isPullDownCol[0] = true;
		tableContents.isPullDownCol[2] = true;
		tableContents.pullDownColType[0] = JDPTextGrid.REGULAR;
		tableContents.pullDownColType[2] = JDPTextGrid.REGULAR;
		tableContents.pullDownList[0][0] = new List();
		tableContents.pullDownList[2][0] = new List();

		tableContents.pullDownValue[2][0] = new Vector(); 
		tableContents.pullDownList[2][0].addItem("Net 30"); 
		tableContents.pullDownValue[2][0].addElement("Net 30"); 
		tableContents.pullDownList[2][0].addItem("Net 60"); 
		tableContents.pullDownValue[2][0].addElement("Net 60"); 
		tableContents.pullDownList[2][0].addItem("ON invoice"); 
		tableContents.pullDownValue[2][0].addElement("ON invoice"); 

		tableContents.pullDownValue[0][0] = new Vector(); 
		new JDPLoadChoice(user,jaggSQL,tableContents.pullDownList[0][0],"title","title_id","dbo_titles","(1=1)",tableContents.pullDownValue[0][0]);

	}


	//
	//  Create and load the Search Panel
	//
	public void MasterDetail1WhereClauseMain() {

		String[] MasterDetail1cf = new String[3];
		String[] MasterDetail1acf = new String[3];
		Vector MasterDetail1mu = new Vector();
		Vector MasterDetail1amu = new Vector();
		MasterDetail1cf[0] = "Order Num";
		MasterDetail1acf[0] = "a.ord_num";
		MasterDetail1cf[1] = "Store name";
		MasterDetail1acf[1] = "b.stor_name";
		MasterDetail1cf[2] = "Store Address";
		MasterDetail1acf[2] = "b.stor_address";
		MasterDetail1mu.addElement(new Vector());
		MasterDetail1amu.addElement(new Vector());
		MasterDetail1mu.addElement(new Vector());
		MasterDetail1amu.addElement(new Vector());
		MasterDetail1mu.addElement(new Vector());
		MasterDetail1amu.addElement(new Vector());
		((Vector)MasterDetail1mu.elementAt(0)).addElement("Begins with");
		((Vector)MasterDetail1amu.elementAt(0)).addElement("like");
		((Vector)MasterDetail1mu.elementAt(0)).addElement("Contains");
		((Vector)MasterDetail1amu.elementAt(0)).addElement("like");
		((Vector)MasterDetail1mu.elementAt(1)).addElement("Begins with");
		((Vector)MasterDetail1amu.elementAt(1)).addElement("like");
		((Vector)MasterDetail1mu.elementAt(1)).addElement("Contains");
		((Vector)MasterDetail1amu.elementAt(1)).addElement("like");
		((Vector)MasterDetail1mu.elementAt(2)).addElement("Begins with");
		((Vector)MasterDetail1amu.elementAt(2)).addElement("like");
		((Vector)MasterDetail1mu.elementAt(2)).addElement("Contains");
		((Vector)MasterDetail1amu.elementAt(2)).addElement("like");
		int[] MasterDetail1cl = new int[3];
		boolean[] MasterDetail1cis = new boolean[3];
		MasterDetail1cl[0] = 22;
		MasterDetail1cis[0] = true;
		MasterDetail1cl[1] = 44;
		MasterDetail1cis[1] = true;
		MasterDetail1cl[2] = 44;
		MasterDetail1cis[2] = true;
		MasterDetail1SP1 = new JDPWhereClause(user, targetPanel, "", true, "", MasterDetail1cf, MasterDetail1acf, MasterDetail1mu, MasterDetail1amu, null, null, MasterDetail1cl, MasterDetail1cis, "FROM {oj dbo_sales a LEFT OUTER JOIN dbo_stores b ON a.stor_id = b.stor_id} WHERE (1=1)");
		MasterDetail1SP1.setDSNType("ACCESS");
		MasterDetail1SP1.setDataType(0,12);
		MasterDetail1SP1.setDataType(1,12);
		MasterDetail1SP1.setDataType(2,12);
	}


	//
	//  Create and load the Result List Panel
	//
	public void MasterDetail1SearchResultsMain() {

		String MasterDetail1sf = "a.stor_id,a.ord_num";
		String[] MasterDetail1df = {"a.ord_num"};
		String MasterDetail1wc = "(1=1)";
		String[] MasterDetail1sct = {"Stor name","Stor Address"};
		String[] MasterDetail1sc = {"b.stor_name","b.stor_address"};
		JDPJagg jaggSQL = new JDPJagg(user.jaggPath);
		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");
		MasterDetail1RL1 = new JDPSearchResults(user, targetPanel, true, jaggSQL, false, MasterDetail1sf, MasterDetail1df, MasterDetail1wc, MasterDetail1sct, MasterDetail1sc, MasterDetail1sc, "", true, "Total Entries:");
		int[] MasterDetail1icons = new int[14];
		MasterDetail1icons[0] = 3;
		MasterDetail1icons[1] = 5;
		MasterDetail1icons[2] = 8;
		MasterDetail1RL1.setMinWidth(130);
		MasterDetail1RL1.setIcons(MasterDetail1icons);
		MasterDetail1RL1.setFromWhereClause(" FROM {oj dbo_sales a LEFT OUTER JOIN dbo_stores b ON a.stor_id = b.stor_id} WHERE (1=1)");
		MasterDetail1RL1.clearList("");
		MasterDetail1RL1.loadList();
	}



}

